require "camera"


function love.load()
    
	love.physics.setMeter(64)
	world = love.physics.newWorld(0,1000*64)
	
	
	objects = {}
	objects.ground = {}
	
	objects.ground.body = love.physics.newBody(world, 800, 600) --remember, the shape (the rectangle we create next) anchors to the body from its center, so we have to move it to (650/2, 650-50/2)
	objects.ground.shape = love.physics.newRectangleShape(650, 50) --make a rectangle with a width of 650 and a height of 50
	objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape); --attach shape to body
	
	player = { -- nice and organised.
        x = 0,
        y = 0,
        y_velocity = 0,
		x_velocity = 0,
		speed = 2000,
		jetpack_fuel = 0.5,
		jetpack_fuel_max = 0.5,
		friction = 9,
		image = love.graphics.newImage("resources/mm.png") -- let's just re-use this sprite.
    }
	

	gravity = 1000
	jump_height = 180
	

    winW, winH = love.graphics.getWidth(), love.graphics.getHeight() -- this is just
    -- so we can draw it in a fabulous manner.
	
	--initial graphics setup
	love.graphics.setBackgroundColor(104, 136, 248) --set the background color to a nice blue
	love.window.setMode(650, 650) --set the window dimensions to 650 by 650
end

function love.update(dt)
    if player.jetpack_fuel > 0 -- we can still move upwards
    and love.keyboard.isDown("z") then -- and we're actually holding space
        player.jetpack_fuel = player.jetpack_fuel - dt -- decrease the fuel meter
        player.y_velocity = player.y_velocity + jump_height * (dt / player.jetpack_fuel_max)
    end
    if player.y_velocity ~= 0 then -- we're probably jumping
        player.y = player.y + player.y_velocity * dt -- dt means we wont move at
        -- different speeds if the game lags
        player.y_velocity = player.y_velocity - gravity * dt
        if player.y < 0 then -- we hit the ground again
            player.y_velocity = 0
            player.y = 0
            player.jetpack_fuel = player.jetpack_fuel_max
        end
    end
	player.x = player.x + player.x_velocity * dt
	player.y = player.y + player.y_velocity * dt
	player.x_velocity = player.x_velocity * (1 - math.min(dt*player.friction,1))
	
	if love.keyboard.isDown('right') and
		player.x_velocity < player.speed then
			player.x_velocity = player.x_velocity + player.speed * dt
		
	end
	if love.keyboard.isDown('left') and
		player.x_velocity > -player.speed then
			player.x_velocity = player.x_velocity - player.speed * dt
		
	end
	
	
	
	
end

function love.keypressed(key)
    if key == "z" then
        if player.y_velocity == 0 then -- we're probably on the ground, let's jump
            player.y_velocity = jump_height
        end
    end
	
end




function love.draw()
    --camera:set()
	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.image, player.x, -player.y)
	love.graphics.setColor(72, 160, 14) -- set the drawing color to green for the ground
	love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints())) -- draw a "filled in" polygon using the ground's coordinates

     -- trust me
    -- on the origin position. just trust me.
	--camera:unset()
end